REBOL [
   Title:   "Find currency codes and full name"
   Author:  "Dick Whiting"
   Email:   dwhiting@europa.com
   Date:    07-Oct-1998
   File:    %currency.r
   Purpose: {
      Locate and display code and full name for partial currency name
   }
   Comment: {

      Reads the currency table produced by bldrates.r          
      Locates possible matches based on a partial name.

      Name is hardcoded as %rates.table
      
      Invoke script with args of: 

         string/A [PIPE/S pipename/A]

      If run with a second argument of "PIPE" then writes a message
      to the third argument which should be PIPE:some.pipe.name

   }
]

if pick rebol/args 1 [
   arg1: pick rebol/args 1
   mode: pick rebol/args 2
]
else [
   prin "Enter string to look for: "
   arg1: input
   mode: "NONE"
]

if mode = "PIPE" [
   pipe: make file! pick rebol/args 3
]

insert head arg1 "*"
insert tail arg1 "*"

search: head arg1

rtabl: load %rates.table

max: length? rtabl

forall rtabl [
   if ((index? rtabl) > (max - 2)) [break]
   if match/any second rtabl head search [
      if (mode = "PIPE") [
         write pipe reduce [first rtabl second rtabl third rtabl]
         write pipe newline
      ]
      else [
         print [first rtabl second rtabl third rtabl]
      ]
   ]
]


if (mode = "PIPE") [
   write pipe "DONE"
   quit
]
else [halt]

